const Main = imports.ui.main;
const Config = imports.misc.config;
const Me = imports.misc.extensionUtils.getCurrentExtension();
const Panel = Me.imports.modules.panel;
const Profile = Me.imports.modules.profile;
const Log = Me.imports.modules.log;
var Extension = class Extension {
    constructor() {
        this.PowerProfileIndicatorInstance = null;
        this.profileClient = null;
    }
    enable() {
        let systemMenu = null;
        if (parseInt(Config.PACKAGE_VERSION) < 43) {
            systemMenu = Main.panel.statusArea.aggregateMenu;
        }
        else {
            systemMenu = Main.panel.statusArea.quickSettings;
        }
        if (typeof systemMenu == 'undefined') {
            Log.raw('init', 'system menu is not defined');
            return false;
        }
        if (systemMenu._powerProfiles) {
            this.PowerProfileIndicatorInstance = new Panel.PowerProfileIndicator();
            systemMenu._indicators.remove_child(systemMenu._power);
            systemMenu._indicators.add_child(this.PowerProfileIndicatorInstance);
            systemMenu._indicators.add_child(systemMenu._power);
            this.profileClient = new Profile.profileClient();
            this.profileClient.start();
        }
    }
    disable() {
        var _a;
        (_a = this.profileClient) === null || _a === void 0 ? void 0 : _a.stop();
        this.PowerProfileIndicatorInstance.destroy();
        this.PowerProfileIndicatorInstance = null;
    }
}
function init() {
    ext = new Extension();
    return ext;
}
//# sourceMappingURL=extension.js.map